<template>
    <div class="flex items-end justify-between mb-4">
        <div class="flex items-end gap-3">
            <div class="form-control">
                <div class="text-sm">Từ khóa:</div>
                <label for="keyword">
                    <input
                        @keyup="search"
                        v-model="keyword"
                        id="keyword"
                        type="text"
                        class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                        placeholder="Từ khóa..."
                        autocomplete="off"
                    />
                </label>
            </div>
            <BasicButton
                @click="search"
                classCustom="bg-color-warning hover:shadow-hover-warning"
            >
                <SearchIcon class="text-white" />
                <span>Tìm kiếm</span>
            </BasicButton>
        </div>
    </div>

    <table>
        <thead>
            <tr>
                <th>Thông tin khóa học</th>
                <th>Mô tả bài học</th>
                <th>Thời gian tạo</th>
                <th class="text-center">Hành động</th>
            </tr>
        </thead>
        <tbody>
            <template v-if="lessonsComputed && lessonsComputed.length">
                <tr :key="lesson.id" v-for="lesson in lessonsComputed">
                    <td class="max-w-2xl">
                        <div class="flex gap-3">
                            <img
                                :src="
                                    lesson.image
                                        ? lesson.image
                                        : require('@/assets/images/no-image.webp')
                                "
                                class="w-28 min-w-28 h-full"
                                alt=""
                            />
                            <div>
                                <div class="text-lg font-semibold">
                                    {{ lesson.name }}
                                </div>
                                <div
                                    v-if="lesson.test"
                                    class="box-actions flex items-center gap-1"
                                >
                                    <span class="text-gray-600">
                                        Bài kiểm tra: {{ lesson.test.name }}
                                    </span>
                                    <router-link
                                        :to="{
                                            name: 'admin-test-view',
                                            params: {
                                                courseId: course.id,
                                                testId: lesson.test.id
                                            }
                                        }"
                                        v-tooltip="'Xem'"
                                        class="action-view"
                                    >
                                        <EyeIcon class="w-4 h-4" />
                                    </router-link>
                                </div>
                            </div>
                        </div>
                    </td>
                    <td>
                        <p class="line-clamp-5" v-html="lesson.description"></p>
                    </td>
                    <td>{{ lesson.created_at }}</td>
                    <td>
                        <div
                            class="box-actions flex items-center justify-center gap-1"
                        >
                            <router-link
                                :to="{
                                    name: 'admin-lesson-view',
                                    params: {
                                        courseId: course.id,
                                        lessonId: lesson.id
                                    }
                                }"
                                v-tooltip="'Xem'"
                                class="action-view"
                            >
                                <EyeIcon />
                            </router-link>
                        </div>
                    </td>
                </tr>
            </template>
            <template v-else>
                <tr class="no-data-table">
                    <td colspan="6" class="text-center">
                        Không có dữ liệu
                    </td>
                </tr>
            </template>
        </tbody>
    </table>
</template>

<script>
import { computed, ref } from "vue";
import { useRoute, useRouter } from "vue-router";
import timeHelper from "@/helper/timeHelper";

import { SearchIcon, EyeIcon } from "@heroicons/vue/outline";
import BasicButton from "@/components/button/BasicButton.vue";

export default {
    components: {
        SearchIcon,
        EyeIcon,
        BasicButton
    },
    props: {
        course: {
            type: Object,
            required: true
        }
    },
    setup(props) {
        const route = useRoute();
        const router = useRouter();
        const keyword = ref(route.query.keyword || null);
        const lessons = ref(props.course.lessons);

        const lessonsComputed = computed(() => {
            if (lessons.value && lessons.value.length) {
                return lessons.value.map(lesson => {
                    return {
                        ...lesson,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(lesson.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        function search() {
            let keywordSearch = keyword.value.toLowerCase();

            router.push({
                path: route.path,
                query: { keyword: keyword.value },
                hash: route.hash
            });

            lessons.value = props.course.lessons.filter(lesson => {
                if (
                    lesson.name &&
                    lesson.name.toLowerCase().indexOf(keywordSearch) >= 0
                ) {
                    return true;
                }
                if (
                    lesson.description &&
                    lesson.description.toLowerCase().indexOf(keywordSearch) >= 0
                ) {
                    return true;
                }
                return false;
            });
        }

        return {
            keyword,
            lessonsComputed,
            search
        };
    }
};
</script>
